﻿'Credits to: Gerard Daniels, Pak Bobi, Bonitoo Takeshy

Public Module SqlStringBuilder

    Public Class SQLSelectBuilder
        Private SqlCommand As String = ""
        Private Tables As ArrayList
        Private OutputFields As ArrayList
        Private WhereList As ArrayList
        Private OrderList As ArrayList
        Private Joinfields As ArrayList
        Private CaseList As ArrayList
        Private GroupList As ArrayList
        Private Casefield As String = ""
        Private MaxLimit As String = ""

        Property getsqlcommand() As String
            Get
                Me.CreateCommand()
                lastSQL = SqlCommand
                Return SqlCommand
            End Get
            Set(ByVal Value As String)
                SqlCommand = Value
            End Set
        End Property

        Public Sub New()
            Me.Reset()
        End Sub

        Public Sub Reset()
            'Kosongkan semua variabel
            Me.Tables = New ArrayList
            Me.OutputFields = New ArrayList
            Me.WhereList = New ArrayList
            Me.OrderList = New ArrayList
            Me.Joinfields = New ArrayList
            Me.CaseList = New ArrayList
            Me.GroupList = New ArrayList
            Me.Casefield = ""
            Me.MaxLimit = ""

        End Sub

        Protected Sub CreateCommand()
            'Buat command SQL dan tambahkan ke database

            SqlCommand = ""
            Dim Fitem As SQLStringField
            Dim lfirst As Boolean = True
            Dim cLastitem As String = ""
            'Pertama-tama tambahkan field yang dipilih
            For Each Fitem In OutputFields
                If SqlCommand = "" Then
                    SqlCommand = "Select " + Fitem.cFieldname
                    cLastitem = Fitem.cFieldname
                    '.ToString()
                    lfirst = False

                Else
                    If UCase(Microsoft.VisualBasic.Left(cLastitem, 3)) = "TOP" Then
                        'Jika item terakhir seperti TOP 1 jangan tambahkan tanda baca koma
                        SqlCommand = SqlCommand + " " + Fitem.cFieldname
                        cLastitem = Fitem.cFieldname
                    Else
                        SqlCommand = SqlCommand + ", " + Fitem.cFieldname
                        cLastitem = Fitem.cFieldname
                    End If

                End If
            Next Fitem
            'Jika ada nilai pada statement CASE
            If Me.Casefield <> "" Then
                If lfirst = True Then 'belum ada perintah SELECT!
                    SqlCommand = "Select " + "'" + Me.Casefield + "'= CASE "
                Else    'Field-field telah ada
                    SqlCommand = SqlCommand + ", '" + Me.Casefield + "'= CASE "
                End If
                Dim caseitem As SQLCaseWhenObject
                For Each caseitem In Me.CaseList
                    If caseitem.CData = "IS NULL" Then
                        SqlCommand = SqlCommand + "WHEN " + caseitem.cFieldname + " IS NULL THEN " + caseitem.cReturn + " "
                    Else
                        SqlCommand = SqlCommand + "WHEN " + caseitem.cFieldname + "= " + caseitem.CData + " THEN " + caseitem.cReturn + " "
                    End If
                Next
                SqlCommand = SqlCommand + " END "
            End If
            'Tambahkan tabel
            Dim TableItem As SQLTableField
            lfirst = True
            For Each TableItem In Tables
                If lfirst = True Then
                    SqlCommand = SqlCommand + " FROM " + TableItem.cTablename
                    lfirst = False
                Else
                    SqlCommand = SqlCommand + ", " + TableItem.cTablename
                    '.ToString()
                End If
            Next

            ' Item pertama tidak memiliki statement ANDOR!!
            Dim Jitem As SQLJoinStatement
            For Each Jitem In Joinfields
                If Jitem.cField2 = "" Then
                    'joinType = tipe join
                    SqlCommand = SqlCommand + " " + Jitem.cJoinType + " "
                ElseIf Jitem.cTable2 = "" Then 'Jika kosong, masukkan parameter seperti a=1, bukan nama field

                    SqlCommand = SqlCommand + " " + Jitem.cJoinType + " " + Jitem.cTable1 + " ON " + Jitem.cTable1 + "." + Jitem.cField1 + " " & _
                Jitem.cCompare + " " + Jitem.cField2
                Else
                    SqlCommand = SqlCommand + " " + Jitem.cJoinType + " " + Jitem.cTable1 + " ON " + Jitem.cTable1 + "." + Jitem.cField1 + " " & _
                Jitem.cCompare + " " + Jitem.cTable2 + "." + Jitem.cField2
                End If

            Next
            lfirst = True
            Dim Witem As SQLWhereField
            For Each Witem In WhereList
                If Len(Witem.cField.Trim) = 0 Then
                    lfirst = False
                    SqlCommand = SqlCommand + " " + Witem.cData + " "
                Else
                    If lfirst = True Then
                        lfirst = False
                        SqlCommand = SqlCommand + " WHERE (" + Witem.cField + " " + Witem.cCompare + " " + Witem.cData + ") "
                    Else
                        SqlCommand = SqlCommand + " " + UCase(Witem.candor) + " (" + Witem.cField + " " + Witem.cCompare + " " + Witem.cData + ") "
                    End If
                End If

            Next
            lfirst = True
            Dim Oitem As SQLOrderStatement
            For Each Oitem In OrderList
                If lfirst = True Then
                    lfirst = False
                    If Oitem.cTable = "" Then
                        'If item.ctable.ToString = "" Then
                        SqlCommand = SqlCommand + " ORDER BY " + Oitem.cOrderField + " " + Oitem.cDirection
                    Else
                        SqlCommand = SqlCommand + " ORDER BY " + Oitem.cTable + "." + Oitem.cOrderField + " " + Oitem.cDirection
                    End If
                Else
                    If Oitem.cTable = "" Then
                        SqlCommand = SqlCommand + " ," + Oitem.cOrderField + " " + Oitem.cDirection
                    Else
                        SqlCommand = SqlCommand + " , " + Oitem.cTable + "." + Oitem.cOrderField + " " + Oitem.cDirection
                    End If
                End If

            Next

            Dim Gitem As SQLGroupStatement
            For Each Gitem In GroupList
                If lfirst = True Then
                    lfirst = False
                    SqlCommand = SqlCommand + " GROUP BY " + Gitem.cOrderField + " "
                Else
                    SqlCommand = SqlCommand + " ," + Gitem.cOrderField + " "

                End If

            Next

            If Me.MaxLimit.Trim.Length <> 0 Then
                SqlCommand = SqlCommand + MaxLimit
            End If
        End Sub

        Public Sub AddCaseField(ByVal Fieldname As String)
            'Fieldname merupakan nama field yang akan dimasukkan ke dalam CASE
            'gunakan addcasewhen() untuk mendapatkan return value
            Me.Casefield = Fieldname
        End Sub

        Public Sub AddCaseWhen(ByVal FieldName As String, ByVal Value As String, ByVal oReturn As String)
            Me.CaseList.Add(New SQLCaseWhenObject(FieldName, "'" + Value.ToString + "'", "'" + oReturn.ToString + "'"))
        End Sub

        Public Sub AddCaseWhen(ByVal FieldName As String, ByVal Value As Date, ByVal oReturn As Date)
            Dim Mystring As String = ""
            Dim Mydate As String
            'yyyy-mm-dd hh:mi:ss
            Mystring = Value.Year.ToString.PadLeft(4, CChar("0")) + "-" + Value.Month.ToString.PadLeft(2, CChar("0")) + "-" + _
            Value.Day.ToString.PadLeft(2, CChar("0")) + " " + Value.Hour.ToString.PadLeft(2, CChar("0")) + ":" + _
            Value.Minute.ToString.PadLeft(2, CChar("0")) + ":" + Value.Second.ToString.PadLeft(2, CChar("0"))
            Mydate = "date('" & Mystring & "')"
            Me.CaseList.Add(New SQLCaseWhenObject(FieldName, Mydate, "'" + oReturn.ToString + "'"))
        End Sub

        Public Sub AddCaseWhen(ByVal FieldName As String, ByVal Value As Date, ByVal oReturn As String)
            Dim Mystring As String = ""
            Dim Mydate As String
            'yyyy-mm-dd hh:mi:ss
            Mystring = Value.Year.ToString.PadLeft(4, CChar("0")) + "-" + Value.Month.ToString.PadLeft(2, CChar("0")) + "-" + _
            Value.Day.ToString.PadLeft(2, CChar("0")) + " " + Value.Hour.ToString.PadLeft(2, CChar("0")) + ":" + _
            Value.Minute.ToString.PadLeft(2, CChar("0")) + ":" + Value.Second.ToString.PadLeft(2, CChar("0"))
            Mydate = "date('" & Mystring & "')"
            Me.CaseList.Add(New SQLCaseWhenObject(FieldName, Mydate, "'" + oReturn.ToString + "'"))
        End Sub

        Public Sub AddCaseWhen(ByVal FieldName As String, ByVal Value As String, ByVal oReturn As Date)
            Dim Mystring As String = ""
            Dim Mydate As String
            'yyyy-mm-dd hh:mi:ss
            Mystring = oReturn.Year.ToString.PadLeft(4, CChar("0")) + "-" + oReturn.Month.ToString.PadLeft(2, CChar("0")) + "-" + _
            oReturn.Day.ToString.PadLeft(2, CChar("0")) + " " + oReturn.Hour.ToString.PadLeft(2, CChar("0")) + ":" + _
            oReturn.Minute.ToString.PadLeft(2, CChar("0")) + ":" + oReturn.Second.ToString.PadLeft(2, CChar("0"))
            Mydate = "date('" & Mystring & "')"

            Me.CaseList.Add(New SQLCaseWhenObject(FieldName, Value.ToString, Mydate))
        End Sub

        Public Sub AddCaseWhen(ByVal FieldName As String, ByVal Value As Object, ByVal oReturn As String)
            Me.CaseList.Add(New SQLCaseWhenObject(FieldName, Value.ToString, "'" + oReturn.ToString + "'"))
        End Sub

        Public Sub AddCaseWhenField(ByVal FieldName As String, ByVal Value As Object, ByVal oReturn As Object)
            'Jika ingin mengembalikan nilai dari sebuah field (bukan string atau object) gunakan fungsi ini
            Me.CaseList.Add(New SQLCaseWhenObject(FieldName, Value.ToString, oReturn.ToString))
        End Sub

        Public Sub AddCaseWhen(ByVal FieldName As String, ByVal Value As String, ByVal oReturn As Object)
            Me.CaseList.Add(New SQLCaseWhenObject(FieldName, "'" + Value.ToString + "'", oReturn.ToString))
        End Sub

        Public Sub AddCaseWhen(ByVal FieldName As String, ByVal Value As Object, ByVal oReturn As Object)
            Me.CaseList.Add(New SQLCaseWhenObject(FieldName, Value.ToString, oReturn.ToString))
        End Sub

        Public Sub AddTable(ByVal cTable As String)
            Me.Tables.Add(New SQLTableField(cTable))
        End Sub


        Public Sub AddField(ByVal cField As String)
            Me.OutputFields.Add(New SQLStringField(cField))
        End Sub
        Public Sub AddLimit(ByVal cField As String)
            Me.MaxLimit = " Limit" + cField + " "
        End Sub


        Public Sub AddField(ByVal cField As String, ByVal cAlias As String)
            Me.OutputFields.Add(New SQLStringField(cField + " AS " + cAlias))
            'Anggaplah sebagai string
        End Sub

        Public Sub AddJoin(ByVal cJoinType As String, ByVal cJoinTable1 As String, ByVal cJoinField1 As String, ByVal cComparison As String, ByVal cJoinTable2 As String, ByVal cJoinField2 As String)
            'Contoh Addjoin("INNER JOIN","ID_Department","departmentid","=","ID_continent","Continentid")
            'Hasil: inner join id_department on id_department.departmentid = id_continent.continentid
            Me.Joinfields.Add(New SQLJoinStatement(cJoinType, cJoinTable1, cJoinField1, cComparison, cJoinTable2, cJoinField2))
        End Sub
        Public Sub AddJoin(ByVal cJoinType As String)
            'Contoh: Addjoin("INNER JOIN","ID_Department","departmentid","=","ID_continent","Continentid")
            'Hasil: inner join id_department on id_department.departmentid = id_continent.continentid
            Me.Joinfields.Add(New SQLJoinStatement(cJoinType, "", "", "", "", ""))
        End Sub


        Public Sub AddWhere(ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As String)
            'Contoh: ("FieldInteger",123,"=")
            'Contoh: ("FieldText,"%bonitoo","Like")
            If WhereList.Count = 1 Then

            End If
            If UCase(Ovalue) = "NULL" Then
                Me.WhereList.Add(New SQLWhereField(Cfield, Ovalue.ToString, CompareAs))
            Else
                Me.WhereList.Add(New SQLWhereField(Cfield, PrepareStr(Ovalue.ToString), CompareAs))
            End If

        End Sub
        Public Sub AddWhere(ByVal TotalString As String)
            Me.WhereList.Add(New SQLWhereField("", TotalString, ""))
        End Sub

        Public Sub AddWhere(ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As Date)
            If WhereList.Count = 1 Then

            End If
            Dim Mystring As String = ""
            Dim Mydate As String
            'yyyy-mm-dd hh:mi:ss
            Mystring = Ovalue.Year.ToString.PadLeft(4, CChar("0")) + "-" + Ovalue.Month.ToString.PadLeft(2, CChar("0")) + "-" + _
            Ovalue.Day.ToString.PadLeft(2, CChar("0")) + " " + Ovalue.Hour.ToString.PadLeft(2, CChar("0")) + ":" + _
            Ovalue.Minute.ToString.PadLeft(2, CChar("0")) + ":" + Ovalue.Second.ToString.PadLeft(2, CChar("0"))
            Mydate = "date('" & Mystring & "')"
            Me.WhereList.Add(New SQLWhereField(Cfield, Mydate, CompareAs))
        End Sub

        Public Sub AddWhere(ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As Object)
            'Contoh ("FieldInteger",123,"=")
            'Contoh ("FieldText,"%Bonitoo","Like")
            If WhereList.Count = 1 Then

            End If

            Me.WhereList.Add(New SQLWhereField(Cfield, Ovalue.ToString, CompareAs))
            'Sebagai angka
        End Sub

        Public Sub AddWhere(ByVal cANDOR As String, ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As String)
            'Contoh ("FieldInteger",123,"=","AND")
            'Contoh ("FieldText,"%Bonitoo","Like","OR")
            If WhereList.Count = 0 Then

            End If
            If Trim(UCase(Ovalue)) = "NULL" Then

                Me.WhereList.Add(New SQLWhereField(Cfield, Ovalue.ToString, CompareAs, cANDOR))
            Else
                Me.WhereList.Add(New SQLWhereField(Cfield, PrepareStr(Ovalue.ToString), CompareAs, cANDOR))
            End If
        End Sub

        Public Sub AddWhere(ByVal cANDOR As String, ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As Date)
            'Contoh ("FieldInteger",123,"=","AND")
            'Contoh ("FieldText,"%Bonitoo","Like","OR")
            If WhereList.Count = 0 Then

            End If
            Dim Mystring As String = ""
            Dim Mydate As String
            'yyyy-mm-dd hh:mi:ss
            Mystring = Ovalue.Year.ToString.PadLeft(4, CChar("0")) + "-" + Ovalue.Month.ToString.PadLeft(2, CChar("0")) + "-" + _
            Ovalue.Day.ToString.PadLeft(2, CChar("0")) + " " + Ovalue.Hour.ToString.PadLeft(2, CChar("0")) + ":" + _
            Ovalue.Minute.ToString.PadLeft(2, CChar("0")) + ":" + Ovalue.Second.ToString.PadLeft(2, CChar("0"))
            Mydate = "date('" & Mystring & "')"
            Me.WhereList.Add(New SQLWhereField(Cfield, Mydate, CompareAs, cANDOR))
        End Sub

        Public Sub AddWhere(ByVal cANDOR As String, ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As Object)
            'Contoh ("FieldInteger",123,"=","AND")
            'Contoh ("FieldText,"%Bonitoo","Like","OR")
            If WhereList.Count = 0 Then

            End If

            Me.WhereList.Add(New SQLWhereField(Cfield, Ovalue.ToString, CompareAs, cANDOR))
            'Sebagai angka
        End Sub

        Public Sub AddOrderBy(ByVal FieldName As String, ByVal Direction As String)
            'Contoh ("FieldInteger","DESC")
            'Contoh ("FieldText,"ASC")
            If UCase(Direction) <> "DESC" And UCase(Direction) <> "ASC" Then

                Return
            End If
            Me.OrderList.Add(New SQLOrderStatement(FieldName, Direction))
        End Sub
        Public Sub AddGroupBy(ByVal FieldName As String)
            Me.GroupList.Add(New SQLGroupStatement(FieldName))
        End Sub


        Public Sub AddOrderBy(ByVal TableName As String, ByVal FieldName As String, ByVal Direction As String)
            'Contoh ("FieldInteger","DESC")
            'Contoh ("FieldText,"ASC")
            Me.OrderList.Add(New SQLOrderStatement(TableName, FieldName, Direction))
        End Sub

    End Class
    '*****************************************************************************************
    '' sqlinsert builder
    '*****************************************************************************************
    Public Class SQLInsertBuilder
        Private SqlCommand As String = ""
        Private Tablename As String
        Private DataFields As ArrayList '(Field,Value)
        Private WhereList As ArrayList
        Property getsqlcommand() As String
            Get
                Me.CreateCommand()
                lastSQL = SqlCommand
                Return SqlCommand
            End Get
            Set(ByVal Value As String)
                SqlCommand = Value
            End Set
        End Property

        Public Sub New()
            Me.Reset()
        End Sub
        Public Sub Reset()
            'Bersihkan semua variabel
            Me.Tablename = ""
            Me.DataFields = New ArrayList
            Me.WhereList = New ArrayList
        End Sub
        Protected Sub CreateCommand()
            'Buat Command SQL dan tambahkan ke dalam database
            Dim cAddFields As String = ""
            SqlCommand = ""

            Dim item As SQLDataObject
            Dim lfirst As Boolean = True
            'Pertama, tambahkan field yang dipilih kemudian nilainya
            For Each item In DataFields
                If SqlCommand = "" Then
                    SqlCommand = "Insert Into " + Me.Tablename + " (" + item.cFieldname
                    cAddFields = item.CData
                Else
                    SqlCommand = SqlCommand + ", " + item.cFieldname
                    cAddFields = cAddFields + ", " + item.CData
                End If
            Next item
            SqlCommand = SqlCommand + ") VALUES (" + cAddFields + ") "

            'Item pertama tidak memiliki ANDOR!!
            lfirst = True
            Dim witem As SQLWhereField
            For Each witem In WhereList
                If lfirst = True Then
                    lfirst = False
                    SqlCommand = SqlCommand + " WHERE " + witem.cField.ToString + " " + witem.cCompare.ToString + " " + witem.cData.ToString
                Else
                    SqlCommand = SqlCommand + " " + UCase(witem.candor.ToString) + " " + witem.cField.ToString + " " + witem.cCompare.ToString + " " + witem.cData.ToString
                End If

            Next
            lfirst = True


        End Sub
        Public Sub AddTable(ByVal cTable As String)
            Me.Tablename = cTable
            'createcommand()
        End Sub
        Public Sub AddField(ByVal cField As String, ByVal OObject As String)
            '                Dim DataObject As New SqlDataObJect(cField, OObject)
            'Jika menggunakan fungsi getdate() tidak bisa ditambahkan sebagai string!!
            If UCase(Trim(OObject.ToString)) = "GETDATE()" Then
                Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))
                'ElseIf Left(OObject.ToString, 1) = "@" Then
                '    Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))

            ElseIf UCase(Trim(OObject.ToString)) = "CURDATE()" Then
                Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))
                'ElseIf Left(OObject.ToString, 1) = "@" Then
                '    Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))
            ElseIf UCase(Trim(OObject.ToString)) = "CURRENT_TIMESTAMP" Then
                Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))

            ElseIf Trim(OObject.ToString) = "NULL" Then
                Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))
            Else
                Me.DataFields.Add(New SQLDataObject(cField, PrepareStr(OObject.ToString)))

                'Sebagai string
            End If
        End Sub
        Public Sub AddField(ByVal cField As String, ByVal OObject As Date)
            '                Dim DataObject As New SqlDataObJect(cField, OObject)
            Dim Mystring As String = ""
            'yyyy-mm-dd hh:mi:ss
            Mystring = OObject.Year.ToString.PadLeft(4, CChar("0")) + "-" + OObject.Month.ToString.PadLeft(2, CChar("0")) + "-" + _
            OObject.Day.ToString.PadLeft(2, CChar("0")) + " " + OObject.Hour.ToString.PadLeft(2, CChar("0")) + ":" + _
            OObject.Minute.ToString.PadLeft(2, CChar("0")) + ":" + OObject.Second.ToString.PadLeft(2, CChar("0"))

            Me.DataFields.Add(New SQLDataObject(cField, "date('" & Mystring & "')"))
        End Sub


        Public Sub AddField(ByVal cField As String, ByVal OObject As Object)
            '                Dim DataObject As New SqlDataObJect(cField, OObject)
            Dim newstring As String = OObject.ToString
            newstring = Replace(newstring, ",", ".")

            Me.DataFields.Add(New SQLDataObject(cField, newstring))
        End Sub
    End Class

    '*****************************************************************************************
    '' sqlupdate builder
    '*****************************************************************************************
    Public Class SQLUpdateBuilder
        Private SqlCommand As String = ""
        Private Tablename As String
        Private DataFields As ArrayList '(Field,Value)
        Private WhereList As ArrayList
        Property getsqlcommand() As String
            Get
                Me.CreateCommand()
                lastSQL = SqlCommand
                Return SqlCommand
            End Get
            Set(ByVal Value As String)
                SqlCommand = Value
            End Set
        End Property

        Public Sub New()
            Me.Reset()
        End Sub
        Public Sub Reset()
            'Bersihkan semua variabel
            Me.Tablename = ""
            Me.DataFields = New ArrayList
            Me.WhereList = New ArrayList
        End Sub
        Protected Sub CreateCommand()
            'Buat Command SQL dan tambahkan ke dalam database
            SqlCommand = ""

            Dim item As SQLDataObject
            Dim lfirst As Boolean = True
            'Pertama tambahkan field yang dipilih, kemudian baru nilainya
            For Each item In DataFields
                If SqlCommand = "" Then
                    SqlCommand = "Update " + Me.Tablename + " SET " + item.cFieldname + " = " + item.CData
                Else
                    SqlCommand = SqlCommand + ", " + item.cFieldname + " = " + item.CData
                End If
            Next item

            'Item pertama tidak memiliki ANDOR!!
            lfirst = True
            Dim witem As SQLWhereField
            For Each witem In WhereList
                If lfirst = True Then
                    lfirst = False
                    SqlCommand = SqlCommand + " WHERE " + witem.cField.ToString + " " + witem.cCompare.ToString + " " + witem.cData.ToString
                Else
                    SqlCommand = SqlCommand + " " + UCase(witem.candor.ToString) + " " + witem.cField.ToString + " " + witem.cCompare.ToString + " " + witem.cData.ToString
                End If
            Next
        End Sub

        Public Sub AddTable(ByVal cTable As String)
            Me.Tablename = cTable
            'createcommand()
        End Sub

        Public Sub AddField(ByVal cField As String, ByVal OObject As String)
            If UCase(Trim(OObject.ToString)) = "GETDATE()" Then
                Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))
            ElseIf UCase(Trim(OObject.ToString)) = "CURRENT_TIMESTAMP" Then
                Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))
            ElseIf UCase(Trim(OObject.ToString)) = "CURDATE()" Then
                Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))
            ElseIf Microsoft.VisualBasic.Left(OObject.ToString, 1) = "@" Then
                Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))
            ElseIf Trim(OObject.ToString) = "NULL" Then
                Me.DataFields.Add(New SQLDataObject(cField, OObject.ToString))
            Else
                Me.DataFields.Add(New SQLDataObject(cField, "'" + OObject.ToString + "'"))
                'Sebagai string
            End If
        End Sub
        Public Sub AddField(ByVal cField As String, ByVal OObject As Date)
            Dim Mystring As String = ""
            Dim Mydate As String
            'yyyy-mm-dd hh:mi:ss
            Mystring = OObject.Year.ToString.PadLeft(4, CChar("0")) + "-" + OObject.Month.ToString.PadLeft(2, CChar("0")) + "-" + _
            OObject.Day.ToString.PadLeft(2, CChar("0")) + " " + OObject.Hour.ToString.PadLeft(2, CChar("0")) + ":" + _
            OObject.Minute.ToString.PadLeft(2, CChar("0")) + ":" + OObject.Second.ToString.PadLeft(2, CChar("0"))
            Mydate = "date('" & Mystring & "')"
            Me.DataFields.Add(New SQLDataObject(cField, Mydate))
        End Sub

        Public Sub AddField(ByVal cField As String, ByVal OObject As Object)
            '                Dim DataObject As New SqlDataObJect(cField, OObject)
            'Jika nilai decimal dimasukkan dan settingan pada local menggunakan , dan bukan .
            'maka akan terjadi kesalahan, makanya perlu di ubah terlebih dahulu.. :D
            Dim newstring As String = OObject.ToString
            newstring = Replace(newstring, ",", ".")
            Me.DataFields.Add(New SQLDataObject(cField, newstring))
        End Sub

        Public Sub AddWhere(ByVal cANDOR As String, ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As String)
            'Contoh ("FieldInteger",123,"=","AND")
            'Contoh ("FieldText,"%Bonitoo","Like","OR")
            If WhereList.Count = 0 Then

            End If
            Me.WhereList.Add(New SQLWhereField(Cfield, PrepareStr(Ovalue.ToString), CompareAs, cANDOR))

        End Sub


        Public Sub AddWhere(ByVal cANDOR As String, ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As Date)
            'Contoh ("FieldInteger",123,"=","AND")
            'Contoh ("FieldText,"%Bonitoo","Like","OR")
            If WhereList.Count = 0 Then

            End If
            Dim Mystring As String = ""
            Dim Mydate As String
            'yyyy-mm-dd hh:mi:ss
            Mystring = Ovalue.Year.ToString.PadLeft(4, CChar("0")) + "-" + Ovalue.Month.ToString.PadLeft(2, CChar("0")) + "-" + _
            Ovalue.Day.ToString.PadLeft(2, CChar("0")) + " " + Ovalue.Hour.ToString.PadLeft(2, CChar("0")) + ":" + _
            Ovalue.Minute.ToString.PadLeft(2, CChar("0")) + ":" + Ovalue.Second.ToString.PadLeft(2, CChar("0"))
            Mydate = "date('" & Mystring & "')"

            Me.WhereList.Add(New SQLWhereField(Cfield, Mydate, CompareAs, cANDOR))
        End Sub

        Public Sub AddWhere(ByVal cANDOR As String, ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As Object)
            'Contoh ("FieldInteger",123,"=","AND")
            'Contoh ("FieldText,"%Bonitoo","Like","OR")
            If WhereList.Count = 0 Then

            End If
            Me.WhereList.Add(New SQLWhereField(Cfield, Ovalue.ToString, CompareAs, cANDOR))
        End Sub

        Public Sub AddWhere(ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As String)
            'Contoh ("FieldInteger",123,"=")
            'Contoh ("FieldText,"%Bonitoo","Like")
            If WhereList.Count = 1 Then

            End If
            Me.WhereList.Add(New SQLWhereField(Cfield, PrepareStr(Ovalue.ToString), CompareAs))
        End Sub

        Public Sub AddWhere(ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As Date)
            'Contoh ("FieldInteger",123,"=")
            'Contoh ("FieldText,"%Bonitoo","Like")
            If WhereList.Count = 1 Then

            End If
            Dim Mystring As String = ""
            Dim Mydate As String
            'yyyy-mm-dd hh:mi:ss
            Mystring = Ovalue.Year.ToString.PadLeft(4, CChar("0")) + "-" + Ovalue.Month.ToString.PadLeft(2, CChar("0")) + "-" + _
            Ovalue.Day.ToString.PadLeft(2, CChar("0")) + " " + Ovalue.Hour.ToString.PadLeft(2, CChar("0")) + ":" + _
            Ovalue.Minute.ToString.PadLeft(2, CChar("0")) + ":" + Ovalue.Second.ToString.PadLeft(2, CChar("0"))
            Mydate = "date('" & Mystring & "')"

            Me.WhereList.Add(New SQLWhereField(Cfield, Mydate, CompareAs))
        End Sub

        Public Sub AddWhere(ByVal Cfield As String, ByVal CompareAs As String, ByVal Ovalue As Object)
            'Contoh ("FieldInteger",123,"=")
            'Contoh ("FieldText,"%Bonitoo","Like")
            If WhereList.Count = 1 Then
            End If

            Me.WhereList.Add(New SQLWhereField(Cfield, Ovalue.ToString, CompareAs))
        End Sub

    End Class

    '**************************************************************************
    'Class-class berikut digunakan untuk menambah data ke dalam array
    '**************************************************************************
    Public Class SQLWhereField
        Public cField As String
        Public cData As String
        Public cCompare As String
        Public candor As String

        Public Sub New(ByVal fieldName As String, ByVal Data As String, ByVal CompareAS As String)
            Me.cData = Data
            Me.cField = fieldName
            Me.cCompare = CompareAS
            Me.candor = ""
        End Sub

        Public Sub New(ByVal FieldName As String, ByVal Data As String, ByVal CompareAS As String, ByVal ANDOR As String)
            Me.cData = Data
            Me.cField = FieldName
            Me.cCompare = CompareAS
            Me.candor = ANDOR
        End Sub
    End Class

    Public Class SQLOrderStatement
        Public cOrderField As String
        Public cDirection As String
        Public cTable As String
        Public Sub New(ByVal Orderfield As String, ByVal Direction As String)
            Me.cOrderField = Orderfield
            Me.cDirection = Direction
            Me.cTable = ""
        End Sub
        Public Sub New(ByVal Table As String, ByVal Orderfield As String, ByVal Direction As String)
            Me.cOrderField = Orderfield
            Me.cDirection = Direction
            Me.cTable = Table
        End Sub
    End Class
    Public Class SQLGroupStatement
        Public cOrderField As String
        Public Sub New(ByVal Orderfield As String)
            Me.cOrderField = Orderfield

        End Sub
    End Class

    Public Class SQLJoinStatement
        Public cJoinType As String
        Public cTable1 As String
        Public cTable2 As String
        Public cField1 As String
        Public cField2 As String
        Public cCompare As String
        Public Sub New(ByVal Jointype As String, ByVal Table1 As String, ByVal Field1 As String, ByVal Compare As String, ByVal Table2 As String, ByVal Field2 As String)
            Me.cJoinType = Jointype
            Me.cTable1 = Table1
            Me.cTable2 = Table2
            Me.cField1 = Field1
            Me.cField2 = Field2
            Me.cCompare = Compare
        End Sub
    End Class

    Public Class SQLDataObject
        Public cFieldname As String
        Public CData As String
        Public Sub New(ByVal Fieldname As String, ByVal Data As String)

            Me.cFieldname = Fieldname
            Me.CData = Data
        End Sub
    End Class

    Public Class SQLCaseWhenObject
        Public cFieldname As String
        Public CData As String
        Public cReturn As String
        Public Sub New(ByVal Fieldname As String, ByVal Data As String, ByVal creturnvalue As String)
            Me.cFieldname = Fieldname
            Me.CData = Data
            Me.cReturn = creturnvalue
        End Sub
    End Class

    Public Class SQLStringField
        Public cFieldname As String
        Public Sub New(ByVal Fieldname As String)
            Me.cFieldname = Fieldname
        End Sub
    End Class

    Public Class SQLTableField
        Public cTablename As String
        Public Sub New(ByVal Tablename As String)
            Me.cTablename = Tablename
        End Sub
    End Class
    Public cSQLDATE As String = "GETDATE()"
End Module
